$(document).ready(function () {

  //console.log("constructor_1");

  // $('#calendar').fullCalendar({
  //   header: {
  //     left: 'prev,next today',
  //     center: 'title',
  //     right: 'month,agendaWeek,agendaDay,listWeek'
  //   },
  //   defaultDate: Date(),
  //   navLinks: true, // can click day/week names to navigate views
  //   weekNumbers: true,
  //   weekNumbersWithinDays: true,
  //   weekNumberCalculation: 'ISO',
  //   editable: true,
  //   allDay: true,
  //   events:[ {
  //   title: 'Default Event',
  //       start: '2018-08-07',
  //       end: '2018-08-10'
  //   }],
  //   eventLimit: true, // allow "more" link when too many events
  //   eventDrop: function(event, delta, revertFunc) {
  //     $('#start_date').val(event.start.format());
  //   }
  // });

  var initialLocaleCode = 'en';
  var now = new Date().setMinutes(0);

  $('#fullcalendar_scheduler').fullCalendar({
    schedulerLicenseKey: 'CC-Attribution-NonCommercial-NoDerivatives',
    now: now,
    editable: true, // enable draggable events
    aspectRatio: 1.8, // default: 1.35
    scrollTime: '00:00', // undo default 6am scrollTime
    header: {
      left: 'promptCourse,promptTrainer,promptRoom today prev,next',
      center: 'title',
      right: 'zoomIn,timeline1Day,timeline2Days,timeline3Days,timeline4Days,timeline5Days,timeline1Week,timeline2Weeks,timeline1Month,timeline3Months,timeline6Months,timeline1Year,zoomOut'
    },
    customButtons: {
      // zoomIn: {
      //   text: '<',
      // },
      // zoomOut: {
      //   text: '>',
      // },
      promptCourse: {
        text: '+Course',
        click: function () {
          var title = prompt('Course name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      },
      promptTrainer: {
        text: '+Trainer',
        click: function () {
          var title = prompt('Trainer name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      },
      promptRoom: {
        text: '+Room',
        click: function () {
          var title = prompt('Room name');
          if (title) {
            $('#fullcalendar_scheduler').fullCalendar(
              'addResource',
              { title: title },
              true // scroll to the new resource?
            );
          }
        }
      }
    },
    //defaultView: 'timeline3Days',
    //defaultView: 'timeline1Day',
    defaultView: 'timeline',
    views: {
      // timeline1Day: {
      //   type: 'timeline',
      //   // visibleRange: function(currentDate) {
      //   //   var start_date = currentDate.clone();
      //   //   var end_date = start_date;

      //   //   // TODO: Determination of the end date should be based on repeating event parameters
      //   //   var user_end_date = $.trim($("#end_date").val()).substring(0, 10);
      //   //   if (typeof user_end_date === 'undefined' || user_end_date === null || user_end_date.length == 0) {
      //   //     end_date = user_end_date;
      //   //   }

      //   //   return {
      //   //     start: start_date,
      //   //     end: end_date
      //   //   };
      //   // },
      //   duration: { days: 1 },
      // },
      // timeline2Days: {
      //   type: 'timeline',
      //   duration: { days: 2 }
      // },
      // timeline3Days: {
      //   type: 'timeline',
      //   duration: { days: 3 }
      // },
      // timeline4Days: {
      //   type: 'timeline',
      //   duration: { days: 4 }
      // },
      // timeline5Days: {
      //   type: 'timeline',
      //   duration: { days: 5 }
      // },
      // timeline1Week: {
      //   type: 'timeline',
      //   duration: { weeks: 1 },
      // },
      // timeline2Weeks: {
      //   type: 'timeline',
      //   duration: { weeks: 2 },
      // },
      // timeline1Month: {
      //   type: 'timeline',
      //   duration: { month: 1 },
      // },
      // timeline3Months: {
      //   type: 'timeline',
      //   duration: { month: 3 },
      // },
      // timeline6Months: {
      //   type: 'timeline',
      //   duration: { month: 6 },
      // },
      // timeline1Year: {
      //   type: 'timeline',
      //   duration: { year: 1 },
      // },
    },

    resourceAreaWidth: '20%',
    resourceGroupField: 'resourceType',

    // If refetchResourcesOnNavigate is set to true, the network request will
    // be made with additional parameters: the start/end date of the newly
    // visible window of time, as well as the calendar’s timezone
    //
    // example request: /resource_planner/resources.json?start=2017-12-01&end=2017-01-12&timezone=UTC
    refetchResourcesOnNavigate: true,
    resources: {
      url: '/resource_planner/resources.json',
      type: 'GET',
    },

    eventSources: [
      {
        // Active events
        url: '/resource_planner/resource_events.json',
        type: 'GET',
        error: function () {
          alertDialog.show('there was an error while fetching active events!');
        },
        //color: 'yellow',
        //textColor: 'black',
      },
      {
        // Non-availability / Restrictions
        url: '/resource_planner/resource_restrictions.json',
        type: 'GET',
        error: function () {
          alertDialog.show('there was an error while fetching event restrictions!');
        },
        color: 'grey',
        textColor: 'black',
      },
    ],

    // Callbacks
    resourceRender: function (resourceObj, labelTds, bodyTds) {

      labelTds.on('click', function () {
        //var resource_id = labelTds.parent().attr('data-resource-id');
        var unselected_background_color = 'rgba(0, 0, 0, 0)';
        var selected = (labelTds.css('background-color') != unselected_background_color);

        if (selected) {
          labelTds.css('background-color', unselected_background_color);
          bodyTds.css('background-color', unselected_background_color);
        } else {
          labelTds.css('background-color', 'blue');
          bodyTds.css('background-color', 'cyan');
        }
      });

      // labelTds.css('background', 'blue');
      // bodyTds.css('background', 'yellow');
      // resource_id = labelTds.parent().attr("data-resource-id");
      // labelTds.eq(0).find('.fc-cell-content')
      //   .append(
      //     $('<strong>('+resource_id+')</strong>')
      //     //$('<strong>(?)</strong>')
      //     //.popover({
      //     //  title: resourceObj.title,
      //     //  content: 'test!',
      //     //  trigger: 'hover',
      //     //  placement: 'bottom',
      //     //  container: 'body'
      //     //})
      //   );
    },

    viewRender: function (view, element) {
    },

    eventAfterAllRender: function (view) {
      attachTimelineManipulationHandlers();
      renderScrollBar();
      //debugger;

      //renderHighlighterBar();
      if (window.eventsArray !== undefined) {
        renderEvents(window.eventsArray, window.StartingDate, window.endingDate);
      }
    },

    eventDrop: function (event, delta, revertFunc) {
      if (!confirm(event.title + " was changed to " + event.start.format() + "\nAre you sure about this change?")) {
      //if (!confirmDialog.show(event.title + " was changed to " + event.start.format() + "\nAre you sure about this change?")) {
        revertFunc();
      }
    },

  }); // end fullcalendar() initialisation

  // build the locale selector's options
  $.each($.fullCalendar.locales, function (localeCode) {
    $('#locale-selector').append(
      $('<option/>')
        .attr('value', localeCode)
        .prop('selected', localeCode == initialLocaleCode)
        .text(localeCode)
    );
  });
  setLocaleCode(initialLocaleCode);

  // Timeline update handlers (see timeline_manipulation)
  attachTimelineManipulationHandlers();

  // Attach date/time selectors to the page
  $('.datetimepick').datetimepicker({
    format: 'Y-m-d H:i',
  });

  $('.datepick').datetimepicker({
    timepicker: false,
    format: 'Y-m-d',
  });

  // Initialise the doubleScroll
  renderScrollBar();

  // Initialise the highlighter bar
  renderHighlighterBar();


  //

  /********************************************* Locale Handlers *********************************************/
  // when the selected option changes, dynamically change the calendar option
  $('#locale-selector').on('change', function () {
    if (this.value) {
      setLocaleCode(this.value);
      renderHighlighterBar();
    }
  });
  /*_________________________________________________________________________________________________________*/

  /******************************************** EVENT HANDLERS ***********************************************/

  /*************************************** Start Date Change/Input Handlrers  *******************************************/
  $('#start_date').on('change', function () {
    startDateInput();
  });

  $('#start_date').on('input', function () {
    startDateInput();
  });

  /************************************* End Date Change/Input Handlrers ****************************************/
  $('#end_date').on('change', function () {
    endDateInput();
  });

  $('#end_date').on('input', function () {
    endDateInput();
  });

  /************************************ Change/Input Duration Handlers *****************************************/
  $('#duration').on('change', function () {
    durationInput();
  });

  $('#duration').on('input', function () {
    durationInput();
  });

  /************************************** Duration Minutes/Hours Handlers **************************************/
  /* These two listeners should be kept in sync */
  $('#duration_units').on('change', function () {
    durationUnitInput();
  });

  /******************************************* Reccuring Eevents Handlers **************************************/
  /*************************************************** daily ***************************************************/
  /**** reccurence_pattern ****/
  $('.recurring_event_data.daily input').on('input', function () {
    switch ($(this).val()) {
      case 'every_n_days':                                          // every_n_days radio button clicked
        $("#resource_planner_event_count").val("1");
        break;
      case 'every_weekday':                                         // every_weekday radio button clicked
        $("#resource_planner_event_count").val("");
        break;
      default:                                                        // the number 'n' days is entered
        var values = parseInt($(this).val());
        if ((isNaN(values)) || (values == 0)) {
          $("#resource_planner_event_count").val("");                // not a number or zero not allowed
        } else {                                                   // a valid number has been typed
          document.getElementById("resource_planner_event_count_every_n_days").checked = true;  // check "every_n_days" Radio Button
        }
    }
    if (reccurenceInputStatus("daily")) {                           // check if all required fields are present
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  });

  /*___________________________________________________________________________________________________________*/
  /************************************************** Weekly ***************************************************/
  /**** reccurence_pattern ****/
  $('.recurring_event_data.weekly input').on('input', function () {       // every_n_week(s) field was typed
    var values = parseInt($(this).val());
    if ((isNaN(values)) || (values == 0)) {                               // not a number or zero not allowed
      $('.recurring_event_data.weekly input').val("");                    // set 'every_n_week(s)' field to ""
    } else {                                                              // a valid number has been typed
    }
    if (reccurenceInputStatus("weekly")) {
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  });

  $(document).on("click", ".day_buttons label", function () {         // one of the days of the week was selected
    // var checkbox = $(this).prev('input:checkbox:first');
    // if (checkbox.is(':checked')) {                            // was day unchecked ? (it was checked before)
    //   checkbox.prop("checked", false);                        // set the checkbox object attribute to false (not checked)
    //   $(this).removeClass('day-button-selected');             // set the selected day field to unchecked
    // } else {                                                  // day was checked (was unchecked before)
    //   checkbox.prop("checked", true);                         // set the checkbox object attribute to true (checked)
    //   $(this).addClass('day-button-selected');                // set the selected day field to checked
    // }

    // one of the days of the week was selected
    // check if all required fields are present
    if (reccurenceInputStatus("weekly")) {                    // check if all required fields are present
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  });

  /*___________________________________________________________________________________________________________*/
  /************************************************** Monthly **************************************************/
  /**** reccurence_pattern ****/
  $('.recurring_event_data.monthly input').on('input', function () {               // every_n_week(s) field was typed
    switch ($(this).val()) {
      case 'every_month':
        var selectedMonthDays = $('.recurring_event_data.monthly label.day-button-selected');
        selectedMonthDays.removeClass('day-button-selected');                     // every_n_month(s) radio button was clicked
        $('input[name="resource_planner_event[count]"]').val("1");
        break;
      case 'every_month_day':
        $('input[name="resource_planner_event[count]"]').val("");                 // every_weekday radio button clicked
        break;
      default:                                                                    // the number 'n' days is typed
        selectedMonthDays = $('.recurring_event_data.monthly label.day-button-selected');
        selectedMonthDays.removeClass('day-button-selected');
        var values = parseInt($(this).val());
        if ((isNaN(values)) || (values == 0)) {                                   // not a number or zero not allowed
          $('input[name="resource_planner_event[count]"]').val("");
        } else {                                                                  // a valid number has been typed
          document.getElementById("resource_planner_event_count_every_month").checked = true;  // set "every 'n' month(s)" Radio Button active
        }
    }
    if (reccurenceInputStatus("monthly")) {                                     // check if all required fields are present
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  });

  // How often a day of the week should be used in a month
  $('#resource_planner_event_bymonthday').on('change', function () {
    document.getElementById("resource_planner_event_count_every_month").checked = true;  // set "every 'n' month(s)" Radio Button active
    if (reccurenceInputStatus("monthly")) {                                              // check if all required fields are present
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  });
  /******************************************************************/

  // What day of the week should be used
  $('#resource_planner_event_bymonthday_day').on('change', function () {
    document.getElementById("resource_planner_event_count_every_month").checked = true;  // set "every 'n' month(s)" Radio Button active
    $('.day-button-selected').removeClass('day-button-selected');
    if (reccurenceInputStatus("monthly")) {                                              // check if all required fields are present
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  });
  /******************************************************************/

  // one of the day_of_month was checked or unchecked
  $(document).on("click", ".monthly_day_buttons label", function () {
    // var checkbox = $(this).prev('input:checkbox:first');
    // if (checkbox.is(':checked')) {                                          // if one of the checked days was unchecked
    //   document.getElementById("resource_planner_event_count_every_month_day").checked = true; // set the Radio Button active
    //   $('input[name="resource_planner_event[count]"]').val("");             // set "every 'n' month(s)" field to ""
    //   checkbox.prop("checked", false);                                      // set the checkbox object attribute to false (not checked)
    //   $(this).removeClass('day-button-selected');                           // set the selected day field to unchecked
    // } else {                                                                // if one of the unchecked days was checked
    //   document.getElementById("resource_planner_event_count_every_month_day").checked = true; // set the Radio Button active
    //   $('input[name="resource_planner_event[count]"]').val("");             // set "every 'n' month(s)" field to ""
    //   checkbox.prop("checked", true);                                       // set the checkbox object attribute to true (checked)
    //   //var dayClicked = checkbox[0].name.substring(checkbox[0].name.lastIndexOf("[") + 1, checkbox[0].name.lastIndexOf("]"));
    //   $(this).addClass('day-button-selected');                              // set the selected day field to checked
    // }

    // one of the days of the month was selected
    // check if all required fields are present
    if (reccurenceInputStatus("monthly")) {                                 // check if all required fields are present
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  });
  /******************************************************************/

  // What day of the week should be used
  $('#resource_planner_event_bymonthday_day').on('change', function () {
    document.getElementById("resource_planner_event_count_every_month").checked = true;  // set "every 'n' month(s)" Radio Button active
    $('.day-button-selected').removeClass('day-button-selected');
    if (reccurenceInputStatus("monthly")) {                                              // check if all required fields are present
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  });

  /*___________________________________________________________________________________________________________*/

  /***********************************************************************************************************/
  /**** range_of_reccurence ****/
  $('.range_of_reccurence input').on('input', function () {
    switch ($(this).val()) {
      case 'no_end_date':                                        // no_end_date option selected
        $("#resource_planner_event_until_count").val("");        // make sure the "every [n] days" field is empty
        $("#repeat_until").val("");                              // make sure the "repeat until" field is empty
        break;
      case 'create_n_events':                                   // create 'n' events radio button selected
        $("#resource_planner_event_until_count").val("1");
        $("#repeat_until").val("");                             // make sure the "repeat until" field is empty
        break;
      case 'repeat_until':                                      // repeat untill radio button selected
        $("#resource_planner_event_until_count").val("");       // make sure the "every [n] days" field is empty
        break;
      default:
        var values = parseInt($(this).val());
        if ((isNaN(values)) || (values == 0)) {                 // not a number or zero not allowed
          $("#resource_planner_event_until_count").val("");
        } else {                                                // a valid number has been typed
          document.getElementById("resource_planner_event_until_create_n_events").checked = true;  // set "every 'n' month(s)" Radio Button to checked
          $("#repeat_until").val("");                             // make sure the "repeat until" field is empty
        }
    }
    if (reccurenceInputStatus($.trim($('#resource_planner_event_rrule').val()))) {      // check if all required fields are present
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  });

  // repeat until date selection
  $('#repeat_until').on('change', function () {
    $("#resource_planner_event_until_count").val("");
    document.getElementById("resource_planner_event_until_repeat_until").checked = true;

    if (reccurenceInputStatus($.trim($('#resource_planner_event_rrule').val()))) {    // check if all required fields are present
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  });

}); // end $(document).ready()


//
// Common/Helper functions
//
/*___________________________________________________________________________________________________________*/
function setLocaleCode(localeCode) {
  $.datetimepicker.setLocale(localeCode);
  $('#fullcalendar_scheduler').fullCalendar('option', 'locale', localeCode);
}

/*___________________________________________________________________________________________________________*/
function getEventWindowHeight() {
  // NOTE: Both versions are correct. The second version avoids guesswork about the view parameters

  //var eventWindowHeightRegion = $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller');
  //return eventWindowHeightRegion.height()

  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  //return (view.el.height());
  return (view.spreadsheet.tbodyEl.height());
}

/*___________________________________________________________________________________________________________*/
function getEventWindowWidth() {
  // NOTE: Both versions are correct. The second version avoids guesswork about the view parameters but, does not work

  // The following line was commented out on the 11.11.2018
  //var eventWindowWidthRegion = $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller-canvas');

  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  // Fudge factor to be applied, due to extra table separators

  // The following line was commented out on the 11.11.2018
  //var fudgeFactor = (view.slotDuration.asHours() < 1)  ? 1.015 : 1;

  // new line added on the 11.11.2018
  return view.timeBodyScroller.canvas.width;

  // The following line was commented out on the 11.11.2018
  //return (eventWindowWidthRegion.width() / fudgeFactor);


  //var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  //return (view.slotCnt * view.slotWidth);
}

/*___________________________________________________________________________________________________________*/
function getEventWindowHours() {
  var view = $('#fullcalendar_scheduler').fullCalendar('getView');
  var start = view.intervalStart;
  var end = view.intervalEnd;
  var days = end.diff(start, "days");
  var eventWindowHours = 24 * days;
  return eventWindowHours;
}

/*___________________________________________________________________________________________________________*/
function renderScrollBar() {
  if ($('#doubleScroll_padding').length == 0) {
    $('#fullcalendar_scheduler tbody.fc-body td.fc-resource-area div.fc-scroller').prepend($('<div id="doubleScroll_padding"></div>'));
  }

  $('#fullcalendar_scheduler tbody.fc-body td.fc-time-area div.fc-scroller').doubleScroll({
    onlyIfScroll: true, // top scrollbar is not shown if the bottom one is not present
    resetOnWindowResize: true // recompute the top ScrollBar requirements when the window is resized
  });
}

/*========================================================================================================*/
/*  check presence of all required fields for reccurence                                                  */
/*________________________________________________________________________________________________________*/
function reccurenceInputStatus(reccurencePattern) {

  $('.highlighter').remove();                             // clear previous rendered evenets

  var start_date = $.trim($("#start_date").val());
  var duration = $.trim($("#duration").val());
  var durationUnits = $.trim($("#duration_units").val());

  if (start_date == "") {
    $("#start_date").addClass("input_warning");
  } else {
    $("#start_date").removeClass("input_warning");
  }

  if (duration == "") {
    $("#duration").addClass("input_warning");
  } else {
    $("#duration").removeClass("input_warning");
  }

  if (durationUnits == "") {
    $("#durationUnits").addClass("input_warning");
  } else {
    $("#durationUnits").removeClass("input_warning");
  }

  testStatus(reccurencePattern);

  if (start_date == "" || duration == "" || durationUnits == "") {
    return false;                                                         // some fields are missing
  }

  var reccurenceObject = {        // This object will be passed over to the prepareEvents Function
    startDate: start_date,
    eventDuration: duration,
    durationUnits: durationUnits,
    howOften: "",                 // Every how many days/weeks/months ?
    when: [],                     // Array icluding the week days, or month days (02, 07, 15,...)
    nrOfEvents: "",               // Number of events
    endDate: "",
  }

  var i;
  var values;

  // Check the presence of the reccurence pattern section
  switch (reccurencePattern) {
    case "daily":                                                         // check the presence of the DAILY reccurence pattern fields
      var buttonChecked = $('.recurring_event_data.daily input#resource_planner_event_count_every_n_days');
      if (buttonChecked[0].checked) {        // is every_n_days button is checked...
        var nrDays = $('.recurring_event_data.daily input#resource_planner_event_count').val(); // every_n_days button is checked
        values = parseInt(nrDays);
        if (isNaN(values)) {
          $(".recurring_event_data.daily").addClass("input_warning");
          return false;                                              // 'n' of every 'n' days is missing
        } else {
          $(".recurring_event_data.daily").removeClass("input_warning");
          reccurenceObject.howOften = values;
          break;                                                       // 'n' of every 'n' days is present
        }
      } else {                                                           // every_n_days button is not checked
        buttonChecked = $('.recurring_event_data.daily input#resource_planner_event_count_every_weekday');
        if (buttonChecked[0].checked) {                                 // is every_weekday butoon is checked
          reccurenceObject.howOften = 1;
          $(".recurring_event_data.daily").removeClass("input_warning");
          break;                                                         // every_weekday butoon is checked
        } else {
          $(".recurring_event_data.daily").addClass("input_warning");
          return false;                                                  // every_weekday butoon is not checked
        }
      }
    case "weekly":                                                        // check the presence of the WEEKLY reccurence pattern fields
      var every_n_weeks = $('.recurring_event_data.weekly input').val();            // is 'n' for every_n_weeks field was typed ?
      values = parseInt(every_n_weeks);
      if (isNaN(values)) {
        $(".recurring_event_data.weekly").addClass("input_warning");
        return false;                                                 // if 'n' not a number, e.g. n = "", then stop checking further fields
      } else {
        $(".recurring_event_data.weekly").removeClass("input_warning");                                             // check next field (day of the week)
        reccurenceObject.howOften = values;
        var selectedWeekDays = $('.recurring_event_data.weekly label.day-button-selected');
        if (!selectedWeekDays.length) {                                 // if length = 0 (no day of week was selected)
          $(".recurring_event_data.weekly").addClass("input_warning");
          return false;                                               // some fields are missing
        } else {
          $(".recurring_event_data.weekly").removeClass("input_warning");
          for (i = 0; i < selectedWeekDays.length; i++) {
            reccurenceObject.when[i] = selectedWeekDays[i].innerHTML;
          }
          break;
        }

        //break;
      }
    //}
    case "monthly":                                                   // check the presence of the MONTHLY reccurence pattern fields
      buttonChecked = $('.recurring_event_data.monthly input#resource_planner_event_count_every_month');
      if (buttonChecked[0].checked) {                             // every_n_month button was checked
        var every_n_months = $('.recurring_event_data.monthly input#resource_planner_event_count').val();
        values = parseInt(every_n_months);
        if (isNaN(values)) {
          $(".recurring_event_data.monthly").addClass("input_warning");
          return false;                                         // if 'n' not a number, e.g. n = "", then stop checking further fields
        } else {
          $(".recurring_event_data.monthly").removeClass("input_warning");
          reccurenceObject.howOften = values;
          var cycle = $('.recurring_event_data.monthly select#resource_planner_event_bymonthday').val();
          var whichDay = $('.recurring_event_data.monthly select#resource_planner_event_bymonthday_day').val();
          reccurenceObject.when[0] = cycle;
          reccurenceObject.when[1] = whichDay;
          break;
        }
      } else {
        var selectedCheckedButton = $('.recurring_event_data.monthly input#resource_planner_event_count_every_month_day');   // is the day_of_month button checked ?
        if (!selectedCheckedButton[0].checked) {                                        // if length = 0 (no day of week was selected)
          $(".recurring_event_data.monthly").addClass("input_warning");
          return false;                                                                // some fields are missing
        } else {
          var selectedMonthDays = $('.recurring_event_data.monthly label.day-button-selected');
          if (!selectedMonthDays.length) {                                              // if length !== 0 (day of week was selected)
            $(".recurring_event_data.monthly").addClass("input_warning");
            return false;                                                               // some fields are missing
          } else {
            for (i = 0; i < selectedMonthDays.length; i++) {
              reccurenceObject.when[i] = selectedMonthDays[i].innerHTML;
            }
            $(".recurring_event_data.monthly").removeClass("input_warning");
            break;
          }
        }
      }
  }


  // checking the presence of the range_of_reccurence fields section
  var selectedButton = $('.range_of_reccurence input#resource_planner_event_until_no_end_date');
  if (selectedButton[0].checked) {
    var datum = moment(start_date);
    var endDatum = datum.add(6, 'months');
    reccurenceObject.endDate = endDatum.format();
    prepareEvents(reccurenceObject, reccurencePattern);
    $(".range_of_reccurence").removeClass("input_warning");
    return true;                                                // all required fields are present
  }

  selectedButton = $('.range_of_reccurence input#resource_planner_event_until_create_n_events');        // was create_n_events button checked ?
  if (selectedButton[0].checked) {                                                                      // YES, create_n_events button was checked
    var create_n_events = $('.range_of_reccurence input#resource_planner_event_until_count').val();     // check presence of 'n' events number
    values = parseInt(create_n_events);
    if (isNaN(values)) {                                                                                // is 'n' number of events present ?
      $(".range_of_reccurence").addClass("input_warning");
      return false;                                                               // NO, number of 'n' is not present, stop checking
    } else {
      reccurenceObject.nrOfEvents = values;                                        // Number of events
      $(".range_of_reccurence").removeClass("input_warning");
      prepareEvents(reccurenceObject, reccurencePattern);
      return true;                                                                 // all required fields are present
    }
  } else {
  }

  selectedButton = $('.range_of_reccurence input#resource_planner_event_until_repeat_until');          // was repeat button until checked ?
  if (selectedButton[0].checked) {                                                                   // Yes, check presence of the until date
    var untilDate = $('.range_of_reccurence input#repeat_until.form-control.date-field.datepick');
    var validDate = Date.parse(untilDate[0].value)
    if (validDate) {
      var begin_date = new Date(moment(reccurenceObject.startDate).startOf('day'));
      var newUntilDate = new Date(untilDate[0].value);
      if (newUntilDate < begin_date) {
        untilDate[0].value = "";
        $(".range_of_reccurence").addClass("input_warning");
        return false;
      } else {
        reccurenceObject.endDate = untilDate[0].value;
        prepareEvents(reccurenceObject, reccurencePattern);
        return true;                                                               // all required fields are present
      }
    } else {
      $(".range_of_reccurence").addClass("input_warning");
      return false;                                                              // some fields are missing
    }
  } else {
    $(".range_of_reccurence").addClass("input_warning");
    return false;                                                                 // some fields are missing
  }
}
// end function reccurenceInputStatus
/*========================================================================================================*/

function noReccurence() {
  if ($.trim($('#resource_planner_event_rrule').val()) == "no_repeat") {
    return true;                      // all required fields are present
  }
}
/*========================================================================================================*/

function sleep(ms) {
  return new Promise(resolve => setTimeout(resolve, ms));
}

/*========================================================================================================*/
function testStatus(reccurencePattern) {

  var start_date = $.trim($("#start_date").val());
  var duration = $.trim($("#duration").val());
  var durationUnits = $.trim($("#duration_units").val());

  var reccurenceObject = {        // This object will be passed over to the reccurence event render Function
    startDate: start_date,
    eventDuration: duration,
    durationUnits: durationUnits,
    howOften: "",                 // Every how many days/weeks/months ?
    when: [],                     // Array icluding the week days, or month days (02, 07, 15,...)
    nrOfEvents: "",               // Number of events
    endDate: "",
  }

  var values;

  // Check the presence of the reccurence pattern section
  switch (reccurencePattern) {
    case "daily":                                                         // check the presence of the DAILY reccurence pattern fields
      var buttonChecked = $('.recurring_event_data.daily input#resource_planner_event_count_every_n_days');
      if (buttonChecked[0].checked) {        // is every_n_days button is checked...
        var nrDays = $('.recurring_event_data.daily input#resource_planner_event_count').val(); // every_n_days button is checked
        values = parseInt(nrDays);
        if (isNaN(values)) {
          $(".recurring_event_data.daily").addClass("input_warning");
        } else {
          $(".recurring_event_data.daily").removeClass("input_warning");                                // 'n' of every 'n' days is present
        }
      } else {                                                           // every_n_days button is not checked
        buttonChecked = $('.recurring_event_data.daily input#resource_planner_event_count_every_weekday');
        if (buttonChecked[0].checked) {                                 // is every_weekday butoon is checked
          $(".recurring_event_data.daily").removeClass("input_warning");  // every_weekday butoon is checked
        } else {
          $(".recurring_event_data.daily").addClass("input_warning");     // every_weekday butoon is not checked
        }
      }
      break;

    case "weekly":                                                        // check the presence of the WEEKLY reccurence pattern fields
      var every_n_weeks = $('.recurring_event_data.weekly input').val();            // is 'n' for every_n_weeks field was typed ?
      values = parseInt(every_n_weeks);
      if (isNaN(values)) {
        $(".recurring_event_data.weekly").addClass("input_warning");
      } else {
        $(".recurring_event_data.weekly").removeClass("input_warning");                                             // check next field (day of the week)
        reccurenceObject.howOften = values;
        var selectedWeekDays = $('.recurring_event_data.weekly label.day-button-selected');
        if (!selectedWeekDays.length) {                                 // if length = 0 (no day of week was selected)
          $(".recurring_event_data.weekly").addClass("input_warning");  // some fields are missing
        } else {
          $(".recurring_event_data.weekly").removeClass("input_warning");
        }
      }
      break;

    case "monthly":                                                   // check the presence of the MONTHLY reccurence pattern fields
      buttonChecked = $('.recurring_event_data.monthly input#resource_planner_event_count_every_month');
      if (buttonChecked[0].checked) {                             // every_n_month button was checked
        var every_n_months = $('.recurring_event_data.monthly input#resource_planner_event_count').val()
        values = parseInt(every_n_months);
        if (isNaN(values)) {
          $(".recurring_event_data.monthly").addClass("input_warning"); // if 'n' not a number, e.g. n = "", then stop checking further fields
        } else {
          $(".recurring_event_data.monthly").removeClass("input_warning");
        }
      } else {
        var selectedCheckedButton = $('.recurring_event_data.monthly input#resource_planner_event_count_every_month_day');   // is the day_of_month button checked ?
        if (!selectedCheckedButton[0].checked) {                                        // if length = 0 (no day of week was selected)
          $(".recurring_event_data.monthly").addClass("input_warning");                 // some fields are missing
        } else {
          var selectedMonthDays = $('.recurring_event_data.monthly label.day-button-selected');
          if (!selectedMonthDays.length) {                                              // if length !== 0 (day of week was selected)
            $(".recurring_event_data.monthly").addClass("input_warning");               // some fields are missing
          } else {
            $(".recurring_event_data.monthly").removeClass("input_warning");
          }
        }
      }
      break;
  }


  // checking the presence of the range_of_reccurence fields section
  var selectedButton = $('.range_of_reccurence input#resource_planner_event_until_no_end_date');
  if (selectedButton[0].checked) {
    $(".range_of_reccurence").removeClass("input_warning");       // all required fields are present
    return true;
  }

  selectedButton = $('.range_of_reccurence input#resource_planner_event_until_create_n_events');        // was create_n_events button checked ?
  if (selectedButton[0].checked) {                                                                      // YES, create_n_events button was checked
    var create_n_events = $('.range_of_reccurence input#resource_planner_event_until_count').val();     // check presence of 'n' events number
    values = parseInt(create_n_events);
    if (isNaN(values)) {                                                                                // is 'n' number of events present ?
      $(".range_of_reccurence").addClass("input_warning");                                              // NO, number of 'n' is not present, stop checking
    } else {
      $(".range_of_reccurence").removeClass("input_warning");                                           // all required fields are present
      return true;
    }
  }

  selectedButton = $('.range_of_reccurence input#resource_planner_event_until_repeat_until');          // was repeat button until checked ?
  if (selectedButton[0].checked) {                                                                   // Yes, check presence of the until date
    var untilDate = $('.range_of_reccurence input#repeat_until.form-control.date-field.datepick');
    var validDate = Date.parse(untilDate[0].value)
    if (validDate) {
      var begin_date = new Date(moment(reccurenceObject.startDate).startOf('day'));
      var newUntilDate = new Date(untilDate[0].value);
      if (newUntilDate < begin_date) {
        untilDate[0].value = "";
        $(".range_of_reccurence").addClass("input_warning");
      } else {
        $(".range_of_reccurence").removeClass("input_warning");
        return true;                                                               // all required fields are present
      }
    } else {
      $(".range_of_reccurence").addClass("input_warning");
      return false;                                                              // some fields are missing
    }
  } else {
    $(".range_of_reccurence").addClass("input_warning");
    return false;                                                               // some fields are missing
  }
}                                                                               // end function testStatus

/*========================================================================================================*/
function singleEvevenInputStatus(trigger) {                      // handle singel event input

  //$('.highlighter').remove();

  var start_date = $.trim($("#start_date").val());
  var end_date = $.trim($("#end_date").val());
  var duration = $.trim($("#duration").val());
  var durationUnits = $.trim($("#duration_units").val());

  if (trigger == "start_date") {
    if (end_date !== "") {
      end_date = new Date(end_date);
      start_date = new Date(start_date);
      if (end_date.getTime() <= start_date.getTime()) {
        end_date = $("#start_date").val();
        end_date = new Date(end_date);
        $("#end_date").val(end_date);
        duration = "";
        $("#duration").val(duration);
        return false;
      } else {
        duration = moment(end_date).diff(start_date, "hours");
        duration = renderDuration(duration);
      }
    } else {
      if (duration !== "") {
        end_date = dateAdd(start_date, durationUnits, duration);
        $("#end_date").val(formatDate(end_date));
      }
    }

    if (end_date == "" && duration == "") {
      return false;
    }
  }

  if (trigger == "end_date") {
    end_date = new Date(end_date);
    start_date = new Date(start_date);
    if (end_date.getTime() <= start_date.getTime()) {
      end_date = $("#start_date").val();
      end_date = new Date(end_date);
      $("#end_date").val(end_date);
      duration = "";
      $("#duration").val(duration);
      return false;
    }
    duration = moment(end_date).diff(start_date, "hours");
    duration = renderDuration(duration);
  }

  if (trigger == "duration") {
    end_date = dateAdd(start_date, durationUnits, duration);
    $("#end_date").val(formatDate(end_date));
  }

  var ViewstartDate = moment(start_date).format();
  var ViewendDate = moment(end_date).format();

  var eventsArray = [];
  eventsArray.push({});
  eventsArray[0].startDate = moment(start_date).format();
  eventsArray[0].eventDuration = duration;
  eventsArray[0].durationUnits = durationUnits;

  for (var i = 0; i < eventsArray.length; i++) {
    eventsArray[i].initialStartDate = eventsArray[i].startDate;
    eventsArray[i].initialEventDuration = eventsArray[i].eventDuration;
    eventsArray[i].initialDurationUnits = eventsArray[i].durationUnits;
    eventsArray[i].isDirty = false;
  }

  //console.clear();
  console.log("Start Date: " + moment(ViewstartDate).format());
  console.log("End Date: " + moment(ViewendDate).format());
  console.log(eventsArray);

  window.eventsArray = eventsArray;
  window.StartingDate = ViewstartDate;
  window.endingDate = ViewendDate;
  window.flag = true;

  renderEvents(eventsArray, ViewstartDate, ViewendDate);

}                                                        // End of handle singel event input

/*======================================================================================*/
function renderDuration(eventDurationHours) {
  var durationUnits = $.trim($("#duration_units").val());

  var duration;
  switch (durationUnits) {
    case 'day':
      duration = (eventDurationHours / 24).toFixed(2);
      break;
    case 'hour':
      duration = (eventDurationHours).toFixed(2);
      break;
    case 'minute':
      duration = Math.round(eventDurationHours * 60);
      break;
    default:
      duration = Math.round(eventDurationHours * 60);
  }

  $("#duration").val(duration);
  $("#resource_planner_event_duration").val(duration);
  return duration;
}                                                   // End of renderDuration

/*===========================================================================================================================================*/
function startDateInput() {                           // startDateInput - A date data was typed in the start date field
  var start_date = $.trim($("#start_date").val());
  if (noReccurence()) {
    //updateTimelineDuration(window.startingDate, window.endingDate);
    if (start_date == "" || start_date == 0) {
      $.trim($("#start_date").val(""));
      $.trim($("#duration").val(""));
      $.trim($("#end_date").val(""));
      $("#start_date").addClass("input_warning");
      $("#duration").addClass("input_warning");
      $("#end_date").addClass("input_warning");
      $('.highlighter').remove();
      return;
    } else {
      $("#start_date").removeClass("input_warning");
      singleEvevenInputStatus("start_date");
    }

  } else {
    if (reccurenceInputStatus($.trim($('#resource_planner_event_rrule').val()))) {
      console.log("All input is present, prepare the Objects Array");
      window.flag = true;
    } else {
      console.log("some input is missing !!");
    }
  }
}                                                             // end of startDateInput - A date data was typed in the start date field

/*===========================================================================================================================================*/
function endDateInput() {                          // A date data was typed in the end date field
  var start_date = $.trim($("#start_date").val());
  var duration = $.trim($("#duration").val());
  var end_date = $.trim($("#end_date").val());
  if (noReccurence()) {
    start_date = new Date(start_date);
    end_date = new Date(end_date);
    if ((end_date.getTime() <= start_date.getTime()) || isNaN(end_date) || isNaN(start_date)) {
      end_date = $("#start_date").val();
      $("#end_date").val(end_date);
      duration = "";
      $("#duration").val(duration);
      $("#duration").addClass("input_warning");
      $("#end_date").addClass("input_warning");
      $('.highlighter').remove();
      return;
    }

    //updateTimelineDuration(window.startingDate, window.endingDate);
    if (duration == "" && (end_date == 0 || end_date == "")) {
      $.trim($("#end_date").val(""));
      $("#duration").addClass("input_warning");
      $("#end_date").addClass("input_warning");
      return;
    } else {
      $("#duration").removeClass("input_warning");
      $("#end_date").removeClass("input_warning");
    }
    if (start_date == "") {
      $.trim($("#duration").val(""));
      $.trim($("#end_date").val(""))
      $("#start_date").addClass("input_warning");
      $("#duration").addClass("input_warning");
      $("#end_date").addClass("input_warning");
      return;
    } else {
      $("#start_date").removeClass("input_warning");
    }

    if (end_date == "") {
      $.trim($("#duration").val(""));
      $.trim($("#end_date").val(""))
      $("#duration").addClass("input_warning");
      $("#end_date").addClass("input_warning");
      $('.highlighter').remove();
    } else {
      if (duration == "") {
        duration = moment(end_date).diff(start_date, "hours");
        $.trim($("#duration").val(duration));
        renderDuration(duration);
      }
      singleEvevenInputStatus("end_date");
    }
    //renderHighlighterBar('date');
  } else {
    //reccurencePatternType = $.trim($('#resource_planner_event_rrule').val());
    if (reccurenceInputStatus($.trim($('#resource_planner_event_rrule').val()))) {
      console.log("All input is present, prepare the Objects Array");
      window.flag = true;
    } else {
      console.log("some input is missing !!");
    }
  }
}                                                     // end of endDateInput - A date data was typed in the end date field

/*===========================================================================================================================================*/
function durationInput() {                            // A duration data was typed in the duration field
  var start_date = $.trim($("#start_date").val());
  var duration = $.trim($("#duration").val());
  var end_date = $.trim($("#end_date").val())

  if (noReccurence()) {
    //renderEndDateField();
    if ((duration == 0 || duration == "") && end_date == "") {
      $.trim($("#duration").val(""));
      $("#duration").addClass("input_warning");
      $("#end_date").addClass("input_warning");
    } else {
      $("#duration").removeClass("input_warning");
      $("#end_date").removeClass("input_warning");
    }

    if (start_date == "") {
      $.trim($("#duration").val(""));
      $.trim($("#end_date").val(""))
      $("#start_date").addClass("input_warning");
      $("#duration").addClass("input_warning");
      $("#end_date").addClass("input_warning");
      return;
    } else {
      $("#start_date").removeClass("input_warning");
    }

    if (duration == "") {
      $.trim($("#duration").val(""));
      $.trim($("#end_date").val(""))
      $("#duration").addClass("input_warning");
      $("#end_date").addClass("input_warning");
      $('.highlighter').remove();
    } else {
      singleEvevenInputStatus("duration");
    }

    //renderHighlighterBar('duration');
  } else {
    if (reccurenceInputStatus($.trim($('#resource_planner_event_rrule').val()))) {
      console.log("All input is present, prepare the Objects Array");
      window.flag = true;
    } else {
      console.log("some input is missing !!");
    }
  }
}                                                         // end of durationInput - A duration data was typed in the duration field

/*===========================================================================================================================================*/
function durationUnitInput() {                            // A duration unit data was typed in the duration unit field
  if (noReccurence()) {
    var start_date = $.trim($("#start_date").val());
    var end_date = $.trim($("#end_date").val())
    var duration = moment(end_date).diff(start_date, "hours");
    renderDuration(duration);
  } else {
    if (reccurenceInputStatus($.trim($('#resource_planner_event_rrule').val()))) {
      console.log("All input is present, prepare the Objects Array");
    } else {
      console.log("some input is missing !!");
    }
  }
}                                                      // end of durationUnitInput - A duration unit data was typed in the duration unit field
/*===========================================================================================================================================*/